
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java Http接口加签、验签操作方法_java / iVAN</title>

    <meta name="description" content="Java Http接口加签、验签操作方法_java 1.业务背景 最近接触了一些电商业务,发现在处理电商业务接口时,比如淘宝.支付类接口,接口双方为了确保数据参数在传输过程中未经过篡改,都需要对接口数据进行加签,然后在接口服务器端对接口参数进行验签,确保两个签名是一样的,验签通过之后再进行业务逻辑处理.我们这里主要介绍一下处理思路,至于签名算法我不做过多介绍,网上一大堆. 2.处理思路 双方约定好,参数按特定顺序排列,比如按首字母的顺序排列,如url:http://xxx/xxx.do?a=wersd&amp;b=sd2354&amp;c=4&a ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java Http接口加签、验签操作方法_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1、业务背景 </strong></p>
<p>最近接触了一些电商业务，发现在处理电商业务接口时，比如淘宝、支付类接口，接口双方为了确保数据参数在传输过程中未经过篡改，都需要对接口数据进行加签，然后在接口服务器端对接口参数进行验签，确保两个签名是一样的，验签通过之后再进行业务逻辑处理。我们这里主要介绍一下处理思路，至于签名算法我不做过多介绍，网上一大堆。</p>
<p><strong>2、处理思路 </strong></p>
<p>双方约定好，参数按特定顺序排列，比如按首字母的顺序排列，如url:http://xxx/xxx.do?a=wersd&amp;b=sd2354&amp;c=4&amp;signature=XXXXXXXXXXXX(signature为传入的签名)，等你拿到入参后，将参数串a=wersd&amp;b=sd2354&amp;c=4按你们约定的签名规则，自己用md5加签一次，然后和入参的signature值对比，以确认调用者是否合法，这就是接口签名验证的思路。</p>
<p><strong>3、实例练习 </strong></p>
<p>接口双方经过沟通，对接口达成如下共识：</p>
<p>1、注意事项，主要指接口的的协议、传入参数类型、签名算法、文件格式等说明</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTEyNTA5NDUxOC5qcGc=.jpg"></p>
<p>2、下面是一个电商业务接口的真实案例，双方约定好了接口URL、业务参数、固定参数、签名以及返回数据格式</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTEyNTA5NDUzNy5qcGc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTEyNTA5NDU1Ny5qcGc=.jpg"></p>
<p>接口调用时，接口调用方代码如下(仅供参考)：</p>
<pre>
package com.pcmall;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class APITest {
  static String TEST_URL = "待定";
  static String TEST_KEY = "待定";
  static String TEST_SEC = "待定";					

  public static void main(String[] args) throws UnsupportedEncodingException, NoSuchAlgorithmException {
    String result = getResult(TEST_URL, getReqParam());
    System.out.print(result);
  }					

  private static String getReqParam() throws UnsupportedEncodingException, NoSuchAlgorithmException {
  	TreeMap&lt;String, String&gt; req = new TreeMap&lt;String, String&gt;();
    req.put("a", TEST_KEY);
    req.put("f", "json");
    req.put("l", "zh_CN");
    req.put("m", "zhongan.repair.query");
    req.put("v", "1.0");
    req.put("i", "" + System.currentTimeMillis() / 1000);
    req.put("params", "{\"assignNo\":\"TEST018\"}");
    req.put("s", sign(req, null, TEST_SEC));					

    StringBuilder param = new StringBuilder();
    for (Iterator&lt;Map.Entry&lt;String, String&gt;&gt; it = req.entrySet().iterator(); it.hasNext();) {
      Map.Entry&lt;String, String&gt; e = it.next();
      param.append("&amp;").append(e.getKey()).append("=").append(URLEncoder.encode(e.getValue(), "UTF-8"));
    }					

    return param.toString().substring(1);
  }					

  private static String sign(Map&lt;String, String&gt; paramValues, List&lt;String&gt; ignoreParamNames, String secret) throws NoSuchAlgorithmException, UnsupportedEncodingException {
    StringBuilder sb = new StringBuilder();
    List&lt;String&gt; paramNames = new ArrayList&lt;String&gt;(paramValues.size());
    paramNames.addAll(paramValues.keySet());
    if (ignoreParamNames != null &amp;&amp; ignoreParamNames.size() &gt; 0) {
      for (String ignoreParamName : ignoreParamNames) {
        paramNames.remove(ignoreParamName);
      }
    }
    Collections.sort(paramNames);					

    sb.append(secret);
    for (String paramName : paramNames) {
      sb.append(paramName).append(paramValues.get(paramName));
    }
    sb.append(secret);					

    MessageDigest md = MessageDigest.getInstance("SHA-1");
    return byte2hex(md.digest(sb.toString().getBytes("UTF-8")));
  }					

  private static String byte2hex(byte[] bytes) {
    StringBuilder sign = new StringBuilder();
    for (int i = 0; i &lt; bytes.length; i++) {
      String hex = Integer.toHexString(bytes[i] &amp; 0xFF);
      if (hex.length() == 1) {
        sign.append("0");
      }
      sign.append(hex.toUpperCase());
    }
    return sign.toString();
  }					

  private static String getResult(String urlStr, String content) {
    URL url = null;
    HttpURLConnection connection = null;
    try {
      url = new URL(urlStr);
      connection = (HttpURLConnection) url.openConnection();
      connection.setDoOutput(true);
      connection.setDoInput(true);
      connection.setRequestMethod("POST");
      connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
      connection.setUseCaches(false);
      connection.connect();					

      DataOutputStream out = new DataOutputStream(connection.getOutputStream());
      out.write(content.getBytes("UTF-8"));
      out.flush();
      out.close();					

      BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream(), "UTF-8"));
      StringBuffer buffer = new StringBuffer();
      String line = "";
      while ((line = reader.readLine()) != null) {
        buffer.append(line);
      }
      reader.close();					

      return buffer.toString();
    } catch (IOException e) {
      e.printStackTrace();
    } finally {
      if (connection != null) {
        connection.disconnect();
      }
    }					

    return null;
  }	

}</pre>
<p>服务器端代码如下(仅供参考)：</p>
<pre>
@RequestMapping("/repairTakeOrder")
	@ResponseBody
	public ResponseVO repairTakeOrder(@RequestBody String jsonStr) {
		logger.info("repairTakeOrder入参：" + jsonStr);

		ResponseVO responseVO = null;
		try {
			RepairOrder repairOrder = JackJsonUtil.toBean(jsonStr,
					RepairOrder.class);
			TreeMap&lt;String, String&gt; paramsMap = new TreeMap&lt;String, String&gt;();
			paramsMap.put("gsxx01", repairOrder.getGsxx01());
			paramsMap.put("orderType", repairOrder.getOrderType().toString());
			paramsMap.put("serviceNo", repairOrder.getServiceNo());
			paramsMap.put("vipCard", repairOrder.getVipCard());
			paramsMap.put("customerName", repairOrder.getCustomerName());
			paramsMap.put("customerPhone", repairOrder.getCustomerPhone());
			paramsMap.put("customerTel", repairOrder.getCustomerTel());
			paramsMap.put("province", repairOrder.getProvince());
			paramsMap.put("city", repairOrder.getCity());
			paramsMap.put("county", repairOrder.getCounty());
			paramsMap.put("address", repairOrder.getAddress());
			paramsMap.put("salerCode", repairOrder.getSalerCode());
			paramsMap.put("salerName", repairOrder.getSalerName());
			paramsMap.put("storeCode", repairOrder.getStoreCode());
			paramsMap.put("storeName", repairOrder.getStoreName());
			paramsMap.put("site", repairOrder.getSite());

			paramsMap.put("siteDesp", repairOrder.getSiteDesp());
			paramsMap.put("engineerCode", repairOrder.getEngineerCode());
			paramsMap.put("engineerName", repairOrder.getEngineerName());
			if (repairOrder.getServiceDate() != null) {
				paramsMap.put("serviceDate",
						DateUtils.formatDate(repairOrder.getServiceDate()));
			}

			if (repairOrder.getSalePrice() != null) {
				paramsMap.put("salePrice", repairOrder.getSalePrice()
						.toString());
			}

			paramsMap.put("profitCenter", repairOrder.getProfitCenter());
			paramsMap.put("costCenter", repairOrder.getCostCenter());
			paramsMap.put("gsxx02", repairOrder.getGsxx02());
			paramsMap.put("returnReason", repairOrder.getReturnReason());
			if (repairOrder.getOriOrder() != null) {
				paramsMap.put("oriOrder", repairOrder.getOriOrder().toString());
			}

			if (repairOrder.getOriServiceNo() != null) {
				paramsMap.put("oriServiceNo", repairOrder.getOriServiceNo());
			}

			// 拼接签名原串(a=1&amp;b=2)
			String paramSrc = RequestUtils.getParamSrc(paramsMap);
			logger.info("签名原串：" + paramSrc);
			//进行验签操作
			if (SignUtils.verifymd5(paramSrc, repairOrder.getSign())) {
				//处理业务逻辑
				responseVO=erpServiceImpl.repairTakeOrder(repairOrder);

			} else {
				responseVO = new ResponseVO();
				responseVO.setSuccess(false);
				responseVO.setErrorMsg("验签失败");
			}

		} catch (Exception e) {
			logger.error("", e);
			responseVO = new ResponseVO();
			responseVO.setSuccess(false);
			responseVO.setErrorMsg(StringUtils.isNotBlank(e.getMessage()) ? e.getMessage() : "后台异常");
		}
		return responseVO;

	}</pre>
<p>以上这篇Java Http接口加签、验签操作方法就是小编分享给大家的全部内容了，希望能给大家一个参考，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                验签<br />
                                    接口加签<br />
                                    java api接口签名验证、java接口参数校验、java 接口token验证、java短信验证码接口、java接口签名验证，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-10 15:56:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e6%8e%a5%e5%8f%a3%e5%8a%a0%e7%ad%be/" title="接口加签">接口加签</a>, <a href="https://www.iamivan.net/tag/%e9%aa%8c%e7%ad%be/" title="验签">验签</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java Http接口加签、验签操作方法_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1wBd5z.html" rel="bookmark">php对接java现实加签验签的实例&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我实现的方法,主要是把java生成的密钥转为php能识别的pem格式的密钥,其它的加签.验签采用调用openssl内置签名方法. java生成的密钥主要是字符串:而pem格式密钥是以64位为一行,并且带有如下头和尾的文件格式,然后php再去取得相对应pem格式字符串. pem格式密钥 -----BEGIN PUBLIC KEY----- //64chars一行(多行) -----END PUBLIC KEY----- -----BEGIN RSA PRIVATE KEY----- //64cha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ909Kb.html" rel="bookmark">php对接java现实加签验签的实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我实现的方法,主要是把java生成的密钥转为php能识别的pem格式的密钥,其它的加签.验签采用调用openssl内置签名方法. java生成的密钥主要是字符串:而pem格式密钥是以64位为一行,并且带有如下头和尾的文件格式,然后php再去取得相对应pem格式字符串. pem格式密钥 -----BEGIN PUBLIC KEY----- //64chars一行(多行) -----END PUBLIC KEY----- -----BEGIN RSA PRIVATE KEY----- //64cha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Z7D3b.html" rel="bookmark">将Java程序与数据库进行连接的操作方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个网络关系数据库应用系统是一个三层次结构.客户机与服务器采用网络连接,客户机端应用程序按通信协议与服务器端的数据库程序通信:数据库服务程序通过SQL命令与数据库管理系统通信. Java程序与数据库连接方法有两种.一种是使用JDBC-ODBC桥接器与数据库连接,一种是用纯Java的JDBC驱动程序实现与数据库连接.使用JDBC-ODBC 桥接器与数据库连接 Java程序使用JDBC-ODBC 桥接器与数据库连接,Java程序与数据库通信的过程是: 先由数据库应用程序向ODBC驱动管理器发出API			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9j02Vp.html" rel="bookmark">php rsa 加密，解密，签名，验签详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				php rsa 加密,解密,签名,验签 由于对接第三方机构使用的是Java版本的rsa加解密方法,所有刚开始在网上搜到很多PHP版本的rsa加解密,但是对接java大多都不适用. 以下php版本是适用于对接java接口,java适用密钥再php语言使用是需要添加 -----BEGIN CERTIFICATE----- -----END CERTIFICATE----- 使用密钥:加密公钥  public_key.cer 解密私钥  private_key.key 签名私钥 sign_key.ke			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQN83oM.html" rel="bookmark">实例-ping&plus;&plus; java验签&lpar;签名，公钥，charge&rpar;怎么获取</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 ping++ java验签(签名,公钥,charge)怎么获取 这是官网demo package example;import java.io.FileInputStream;import java.security.InvalidKeyException;import java.security.KeyFactory;import java.security.NoSuchAlgorithmException;import java.security.PublicKey;import			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKQ8nz.html" rel="bookmark">工行验签问题，求做过工行支付接口的人帮忙看看。本人不胜感激。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 工行验签问题,求做过工行支付接口的人帮忙看看.本人不胜感激. 工行B2C支付成功之后的解析验签报错:javax.crypto.BadPaddingException: unknown block type ,i = -1.i = 0 时才是验签正确,求做过的大神指导一下 .. 解决方案 帮顶!同求!和楼主一样也被工行借口无限蹂躏			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVln3b.html" rel="bookmark">农行支付成功，回调验签失败</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 农行支付成功,回调验签失败 农行支付成功,回调时 String msg = request.getParameter(&quot;MSG&quot;); try { PaymentResult pr = new PaymentResult(msg); if(pr.isSuccess()){ System.out.println(&quot;成功&quot;); }else{ System.out.println(&quot;失败&quot;); } } catch (TrxException e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkKB8b.html" rel="bookmark">验签</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1,验签的输入 签名的验证有3个输入: (1)密码(用于签名的种子);(2)签名本身;(3)公钥 2,验签的应用场景 邮件的加密发送 具体步骤: 插上key,key中包含私钥和签名; 弹框要求输入密码; 使用公钥和签名来验证签名,如果密码不对,则验签失败; 若验签成功,则产生随机秘钥E; 使用随机秘钥E加密邮件内容M,得到M2; 使用对方的公钥对E进行加密,得到E2; 把M2,E2,发送给对方. 对方收到之后,使用私钥对E2,进行解密,得到E; 使用E对M2进行解密得到明文邮件.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9joBgp.html" rel="bookmark">md5-MD5认证 验签失败 解决认证问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 MD5认证 验签失败 解决认证问题 抓包修改数据后,总是显示验签失败,应该是MD5认证解决不了,请问这个有办法解决吗 解决方案 不知道在弄什么,按文档要求的加密算法来进行加密和验签			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW72eM.html" rel="bookmark" class="title">Oracle透明网关配置问题</a>
					<div>
						问题描述 Oracle透明网关配置问题 本地配置连接Sqlserver没有问题,连接服务器出现问题,以下为截图: 尝试几种写法,均连接不上,initdg4msql.ora 配置如下: HS_FDS_C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJBxwz.html" rel="bookmark" class="title">UI设计师&colon;熟知常见的web设计模式</a>
					<div>
						网页制作Webjx文章简介:交互设计师常用的web设计模式. 交互设计师在设计线框图原型时,熟知常见的web设计模式很有帮助,做到&quot;心中有数&quot;才能创造出符合需求,用户易学易用的界面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrGG4p.html" rel="bookmark" class="title">用文本&plus;ASP打造新闻发布系统&lpar;四&rpar;新闻删除</a>
					<div>
						&lt;!--#include file=&quot;news_session.asp&quot;--&gt; &lt;% dim idid=Request.QueryString (&quot;id ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA1QvM.html" rel="bookmark" class="title">用ADODB&period;Stream代替FSO读取文本文件</a>
					<div>
						ado|fso|stream 昨天我问过这个问题,不过没人回答到点上,今天搞定了.贴出来给觉得有用的朋友,希望其他朋友不用走弯路. '文件内容读取.Function LoadFile(ByVal Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PW6nM.html" rel="bookmark" class="title">SSRS：使用分组 Group 属性实现基于父子递归关系的汇总报表</a>
					<div>
						基于父子关系的递归结构在公司组织结构里比较常见,基本上都是在一张表里实现的自引用关系.在 报表中如果要实现这种效果,并且在这个基础上做一些数据的汇总,可以使用到下面提到的方法. 要实现的效果大致如下  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jGoVb.html" rel="bookmark" class="title">菜鸟学装机之四 图解适配卡安装</a>
					<div>
						电脑当中有许许多多的适配卡,如:显卡.声卡.网卡.MODEM卡.电视卡.SCSI接口卡.IDE接口卡,它们是通过主板上的AGP.PCI或ISA总线插槽与主板相连接.其实这些适配卡的安装过程都是大同小异 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl955b.html" rel="bookmark" class="title">如何将Oracle RAC 10g升级到Oracle 10&period;2&period;0&period;5</a>
					<div>
						1.Back Up database 一般情况下rman备份 2.备份ocr和vote disk [root@rac2 bin]# ./ocrconfig -export /tmp/ocr_expor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AKNBp.html" rel="bookmark" class="title">有道词典4&period;3正式版发布 网页版单词本新鲜出炉</a>
					<div>
						8月9日,有道词典4.3正式版发布.该版本在4.3Beta版基础之上新增了网页版在线单词本功能,并结合有道搜索技术对释义数据库进行了优化,使新版有道词典能够实现丰富的划词释义功能,更加强大也更具内涵. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kKZdz.html" rel="bookmark" class="title">使用酷我音乐播放MV时花屏怎么办？</a>
					<div>
						花屏一般是由于Windows Media Player组件不全或版本过低等问题引起的,重装Windows Media Player10或更高版本的Windows Media Player即可.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLxXRb.html" rel="bookmark" class="title">360浏览器不能切换输入法怎么办</a>
					<div>
						  1.如果ctrl +shift不能切换的话试试用CTRL+空格键来切换.有时候360浏览器默认一些快捷键和输入法切换键有冲突,我们可以自已设置一下切换快捷键. 2.有时候输入法兼容性不是很好就会出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze70GjM.html" rel="bookmark" class="title">Win7如何设置腾达无线路由器</a>
					<div>
						  步骤一.电脑连接设置 1.首先右击桌面上的&quot;网上邻居&quot;图标,选择弹出菜单中的&quot;属性&quot;命令: 2.在打开的窗口中右击&quot;本地连接&quot;图标,选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7LrDb.html" rel="bookmark" class="title">excel求和产生误差怎么解决</a>
					<div>
						  在财务工资表中,涉及到&quot;工资税金&quot;的计算问题,笔者依照&quot;工资税金&quot;的计算方法,制定出Excel的计算公式,根据每个职工的收入项进行相关的计算后,将运算结果自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZeYvz.html" rel="bookmark" class="title">在Word2013中制作书法字帖</a>
					<div>
						  1.快速制作书法字帖 使用Word2013制作书法字帖的步骤如下所述: 第1步,打开Word2013窗口,依次单击&quot;文件&quot;→&quot;新建&quot;按钮,在&quot;新建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNWQQM.html" rel="bookmark" class="title">Excel2007如何设置自动保存</a>
					<div>
						  对于一个办公族来说,经常避免不了在制作表格的时候办公室突然停电,或者电脑突然死机,遇到这样的事情以后我们第一反应就是:完了,完了,一下午的劳动成果就这样泡汤了.记住这个小秘诀,就算断电.死机你的表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6edZNb.html" rel="bookmark" class="title">驱动精灵2015怎么卸载</a>
					<div>
						  1.在你的电脑桌面的驱动精灵2015上右击再点击强力卸载此软件. 2.在弹出的卸载弹窗中勾选不想使用驱动精灵2015,我要卸载然后点击下一步. 3.如果你不想保存驱动精灵2015下载文件及备份可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Qwmp.html" rel="bookmark" class="title">下载文件图标左下角出现小黄锁怎么办</a>
					<div>
						  电脑在下载文件到桌面时,总会在图标左下角出现一把小黄锁,怎么办? 原因分析: 下载文件时,在图标左下角出现小黄锁,有可能是权限设置问题导致. 解决方案: 1. 进入&quot;c:userleno ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZLEqz.html" rel="bookmark" class="title">阿里云牵手FIFA世俱杯，中国技术积极参与全球体育</a>
					<div>
						下个月,世界球迷瞩目的FIFA世俱杯决赛将在阿联酋开幕.C罗.本泽马等超级球星和他们效力的俱乐部球队都将成为世界球迷关注的焦点--哪个球队能够&quot;王中称王&quot;?哪位球员能在总决赛中创造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YR3vM.html" rel="bookmark" class="title">求一一解答-ssh框架的运行机制等等</a>
					<div>
						问题描述 ssh框架的运行机制等等 介绍下你对MVC设计模式的理解,MVC有什么优点?在SSH框架下的MVC模式是如何工作的? Java中泛型的实现机制. 说说你对Spring的理解 何为事务,事务有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7v9Qz.html" rel="bookmark" class="title">html-Web开发中局部刷新url地址如何改变，浏览器刷新之后页面跳转控制</a>
					<div>
						问题描述 Web开发中局部刷新url地址如何改变,浏览器刷新之后页面跳转控制					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6PD7z.html" rel="bookmark" class="title">java-求助SAX解析XML时为什么不加上stack&period;pop&lpar;&rpar;无法打印出元素文本内容&quest;</a>
					<div>
						问题描述 求助SAX解析XML时为什么不加上stack.pop()无法打印出元素文本内容? package com.shengsiyuan.xml.sax; import java.io.File;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKL3db.html" rel="bookmark" class="title">spring mvc-springMVC&plus;mybatis问题</a>
					<div>
						问题描述 springMVC+mybatis问题 框架搭好之后,启动tomcat 出现: [2016-01-08 05:20:14,898] Artifact demo0:war exploded:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZWqAp.html" rel="bookmark" class="title">c atcher finalize-&dollar;GcWatcher&period;finalize 程序异常</a>
					<div>
						问题描述 $GcWatcher.finalize 程序异常 java.util.concurrent.TimeoutException: com.android.internal.os.BinderI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZeXRz.html" rel="bookmark" class="title">创业中的合作伙伴</a>
					<div>
						刚有时间静下来回顾2010年的创业历程,看见在短短的一年时间里1号店树立了一个又一个里程碑,感到一年走了十年的路,很有成就感.我和合作伙伴峻岭常处于一种亢奋之中,像是坐云霄飞车,有高有低.把我们的想法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjP9WM.html" rel="bookmark" class="title">创建三维头像只需一张自拍，AI 技术即将开启 3D 社交时代？</a>
					<div>
						感觉自拍不够过瘾?来看看这个能把自拍照片转制为三维立体头像的应用. 加州初创公司推出智能 3D 模型软件 Loom.ai ,利用机器学习和计算机视觉技术,根据用户 2D 平面照片,生成 3D 头像.该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBED0M.html" rel="bookmark" class="title">API 设计&colon; RAML、Swagger、Blueprint三者的比较</a>
					<div>
						API设计工具中常常会拿RAML.Swagger.Blueprint这三种工具进行讨论比较,它们都是用来描述和辅助API开发的,只是它们之间的侧重有所不同. RAML RAML(RESTful API ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA5AeM.html" rel="bookmark" class="title">酷派发布新售后政策 首个全面开放ROOT保修</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 新浪科技讯 9月26日消息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq72eez.html" rel="bookmark" class="title">ASP&period;net中网站访问量统计方法代码&lowbar;实用技巧</a>
					<div>
						一.建立一个数据表IPStat用于存放用户信息 我在IPStat表中存放的用户信息只包括登录用户的IP(IP_Address),IP来源(IP_Src)和登录时间(IP_DateTime),些表的信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12dkxp.html" rel="bookmark" class="title">不同级别的程序员</a>
					<div>
						在面试时,你可能会被经常问到&quot;在未来5年,你想干什么?&quot;,这可能是一个比较难回答的问题.在中国,答案一般可能会是Team leader,Manager,或是Architect,Sp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60gZLz.html" rel="bookmark" class="title">中国航天大事：构建北斗卫星导航系统</a>
					<div>
						1994年,中国正式开始北斗卫星导航试验系统(北斗1号)的研制,并在2000年发射了两颗静止轨道卫星,区域性的导航功能得以实现.2003年又发射了一颗备份卫星,完成了北斗卫星导航试验系统的组建. 卫星 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAOv7b.html" rel="bookmark" class="title">unix 的od -r和vi里&percnt;&excl;xxd左边0000000一直往下0000010都代表什么</a>
					<div>
						问题描述 unix 的od -r和vi里%!xxd左边0000000一直往下0000010都代表什么 unix 的od -r和vi里%!xxd左边0000000一直往下0000010都代表什么 解决方 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
